library(gnlm)
library(repeated)
library(growth)
library(event)

y <- as.matrix(read.table("probewor.dat",skip=1))
word <- list()
for(i in 1:11){
	word <- c(word,list(wr(~gl(5,1,5))$design[,2:5]))
	colnames(word[[i]]) <- c("Word2","Word3","Word4","Word5")}
words <- gl(5,1,55)
y <- restovec(y)

z <- glm(response(y)~gl(55,1),fam=poisson)
z$aic/2
print(z <- kalsurv(y,preg=3.4,pinit=0.1,int="Weibull",psh=1,dep="frailty"))
carma(y,pre=1,pos=c(1,1))
29.05/(29.05+42.58308)
carma(y,trans="log",pre=1,pos=c(1,1))
kalsurv(y,preg=3.4,pinit=0.1,int="Weibull",psh=1)
print(zz <- kalsurv(y,preg=3.4,pinit=0.1,int="Weibull",psh=1,dep="frailty",
	tvc=word,ptvc=c(0,0,0,0)))

if(interactive()){
postscript("probe.eps",height=5)
par(mfrow=c(1,2),mar=c(3.5,3.5,3,1),mgp=c(2.5,1,0))
plot(km(response(y),group=gl(5,1,55)),xlim=c(0,55),xlab="Seconds",
	ylab="Survival function",main="")
lines(1:50,exp(zz$coef[6])/(exp(zz$coef[6])+((1:50)/
	exp(zz$coef[1]))^exp(zz$coef[7])))
lines(1:50,exp(zz$coef[6])/(exp(zz$coef[6])+((1:50)/
	exp(zz$coef[1]+zz$coef[2]))^exp(zz$coef[7])),lty=2)
lines(1:50,exp(zz$coef[6])/(exp(zz$coef[6])+((1:50)/
	exp(zz$coef[1]+zz$coef[3]))^exp(zz$coef[7])),lty=3)
lines(1:50,exp(zz$coef[6])/(exp(zz$coef[6])+((1:50)/
	exp(zz$coef[1]+zz$coef[4]))^exp(zz$coef[7])),lty=4)
lines(1:50,exp(zz$coef[6])/(exp(zz$coef[6])+((1:50)/
	exp(zz$coef[1]+zz$coef[5]))^exp(zz$coef[7])),lty=1)
plot(1:50,exp(zz$coef[6])*exp(zz$coef[7])*(((1:50)/exp(zz$coef[1]))^
	(exp(zz$coef[7])-1)/exp(zz$coef[1]))/(exp(zz$coef[6])+((1:50)
	/exp(zz$coef[1]))^exp(zz$coef[7])),type="l",xlab="Seconds",
	ylab="Intensity function",xlim=c(0,55),ylim=c(0,0.3),yaxt="n")
axis(2,c(0,0.1,0.2,0.3))
lines(1:50,exp(zz$coef[6])*exp(zz$coef[7])*(((1:50)/exp(zz$coef[1]
	+zz$coef[2]))^(exp(zz$coef[7])-1)/exp(zz$coef[1]+zz$coef[2]))
	/(exp(zz$coef[6])+((1:50)/exp(zz$coef[1]+zz$coef[2]))^exp(zz$coef[7])),
	lty=2)
lines(1:50,exp(zz$coef[6])*exp(zz$coef[7])*(((1:50)/exp(zz$coef[1]
	+zz$coef[3]))^(exp(zz$coef[7])-1)/exp(zz$coef[1]+zz$coef[3]))
	/(exp(zz$coef[6])+((1:50)/exp(zz$coef[1]+zz$coef[3]))^exp(zz$coef[7])),
	lty=3)
lines(1:50,exp(zz$coef[6])*exp(zz$coef[7])*(((1:50)/exp(zz$coef[1]
	+zz$coef[4]))^(exp(zz$coef[7])-1)/exp(zz$coef[1]+zz$coef[4]))
	/(exp(zz$coef[6])+((1:50)/exp(zz$coef[1]+zz$coef[4]))^exp(zz$coef[7])),
	lty=4)
lines(1:50,exp(zz$coef[6])*exp(zz$coef[7])*(((1:50)/exp(zz$coef[1]
	+zz$coef[5]))^(exp(zz$coef[7])-1)/exp(zz$coef[1]+zz$coef[5]))
	/(exp(zz$coef[6])+((1:50)/exp(zz$coef[1]+zz$coef[5]))^exp(zz$coef[7])),
	lty=1)
dev.off()
}

my <- matrix(response(y),ncol=5,byrow=T)
# Different intensity functions
coxre(my,cens=matrix(rep(1,55),ncol=5),nest=1:11,est=0.7,stratified=T)
# Proportional intensity functions
coxre(my,cens=matrix(rep(1,55),ncol=5),nest=1:11,est=0.7,stratified=F)
# Identical intensity functions
coxre(response(y),cens=rep(1,55),nest=rep(1:11,rep(5,11)),est=0.7)

mu <- function(p,linear) exp(linear)
print(zw1 <- gnlr(y,"Weibull",pmu=c(3.7,0,0,0,0),mu=mu,
	linear=~words,psh=1))
gnlmm(y,"Weibull",pmu=zw1$coef[1:5],mu=mu,linear=~words,psh=2,
	nest=gl(11,5,55),points=3,psd=5.3,scale="identity")
gnlmm(y,"Weibull",pmu=zw1$coef[1:5],mu=mu,linear=~words,psh=2,
	nest=gl(11,5,55),points=3,psd=0.2)
