library(gnlm)
library(repeated)
library(growth)
library(event)

y <- as.matrix(read.table("probewor.dat",skip=1))
resp <- as.vector(t(y))
lresp <- log(resp)
word <- list()
for(i in 1:11){
	word <- c(word,list(wr(~gl(5,1,5))$design[,2:5]))
	colnames(word[[i]]) <- c("Word2","Word3","Word4","Word5")}
words <- gl(5,1,55)
ey <- restovec(exp(y),delta=exp(y))
y <- restovec(y)

gnlr(lresp,"logistic",pmu=3.4,psh=-1,delta=1/resp)
gnlr(lresp,"normal",pmu=3.4,psh=-1,delta=1/resp)
gnlr(resp,"normal",pmu=30,psh=4)
gnlr(resp,"gamma",pmu=30,psh=2.5)
gnlr(resp,"Weibull",pmu=30,psh=1)
mu <- function(p,linear) exp(linear)
print(zg1 <- gnlr(resp,"gamma",pmu=c(3.7,0,0,0,0),mu=mu,linear=~words,psh=1))
print(zw1 <- gnlr(resp,"Weibull",pmu=c(3.7,0,0,0,0),mu=mu,linear=~words,psh=1))
print(zig1 <- gnlr(resp,"inverse Gauss",pmu=c(3.7,0,0,0,0),mu=mu,
	linear=~words,psh=1))
print(zn1 <- gnlr(resp,"normal",pmu=c(30,0,0,0,0),mu=~words,psh=4))

glm(lresp~1,family=gaussian)
summary(glmm(lresp~1,family=gaussian,nest=gl(11,5,55)))
glm(lresp~words,family=gaussian)
summary(glmm(lresp~words,family=gaussian,nest=gl(11,5,55)))
glm(resp~1,family=Gamma(link=log))
summary(glmm(resp~1,family=Gamma(link=log),nest=gl(11,5,55),points=5))
glm(resp~words,family=Gamma(link=log))
summary(glmm(resp~words,family=Gamma(link=log),nest=gl(11,5,55),points=3))
glm(resp~1,family=inverse.gaussian(link=log))
summary(glmm(resp~1,family=inverse.gaussian(link=log),nest=gl(11,5,55),
	points=3))
glm(resp~words,family=inverse.gaussian(link=log))
summary(glmm(resp~words,family=inverse.gaussian(link=log),nest=gl(11,5,55),
	points=3))

mu <- function(p) exp(p[1])
gnlmm(resp,"exponential",pmu=3.5,mu=mu,nest=gl(11,5,55),points=3,psd=0.1)
gnlmm(resp,"gamma",pmu=3.5,mu=mu,psh=1,nest=gl(11,5,55),points=3,psd=0.1)
mu <- function(p,linear) exp(linear)
gnlmm(resp,"exponential",pmu=c(3.5,0,0,0,0),mu=mu,linear=~words,
	nest=gl(11,5,55),points=3,psd=0.1)
gnlmm(resp,"gamma",pmu=zg1$coef[1:5],mu=mu,linear=~words,psh=2.8,
	nest=gl(11,5,55),points=3,psd=4.5,scale="identity")
gnlmm(resp,"gamma",pmu=zg1$coef[1:5],mu=mu,linear=~words,psh=2.8,
	nest=gl(11,5,55),points=3,psd=0.2)
gnlmm(resp,"Weibull",pmu=zw1$coef[1:5],mu=mu,linear=~words,psh=2,
	nest=gl(11,5,55),points=3,psd=5.3,scale="identity")
gnlmm(resp,"Weibull",pmu=zw1$coef[1:5],mu=mu,linear=~words,psh=2,
	nest=gl(11,5,55),points=3,psd=0.2)
gnlmm(resp,"normal",pmu=c(3.6,0,0,0,0),mu=mu,linear=~words,psh=3,
	nest=gl(11,5,55),points=3,psd=4.5)
gnlmm(resp,"normal",pmu=zn1$coef[1:5],mu=~words,psh=3,nest=gl(11,5,55),
	points=3,psd=4.5)
gnlmm(resp,"inverse Gauss",pmu=zig1$coef[1:5],mu=mu,linear=~words,psh=-6,
	nest=gl(11,5,55),points=3,psd=4.5,scale="identity")
gnlmm(resp,"inverse Gauss",pmu=zig1$coef[1:5],mu=mu,linear=~words,psh=-6,
	nest=gl(11,5,55),points=3,psd=0.2)

kalsurv(y,preg=3.4,pinit=0.1)
kalsurv(y,preg=3.4,pinit=0.1,dep="frailty")

kalsurv(y,preg=3.4,pinit=0.1,int="Weibull",psh=1)
print(z <- kalsurv(y,preg=3.4,pinit=0.1,int="Weibull",psh=1,dep="frailty"))
print(zz <- kalsurv(y,preg=3.4,pinit=0.1,int="Weibull",psh=1,dep="frailty",
	tvc=word,ptvc=c(0,0,0,0)))

kalsurv(y,preg=3.4,pinit=0.35,int="gamma",psh=1.4)
kalsurv(y,preg=3.4,pinit=0.2,int="gamma",psh=1.4,dep="frailty")

kalsurv(y,preg=3.4,pinit=0.001,int="log logistic",psh=0.03)
kalsurv(y,preg=3.4,pinit=0.1,int="log logistic",psh=0.1,dep="frailty")

print(z1 <- kalsurv(ey,preg=30,pinit=0.3,int="Weibull",psh=0.1))
print(z2 <- kalsurv(ey,preg=30,pinit=0.7,int="Weibull",psh=0.2,dep="frailty"))

carma(y)
carma(y,pre=1,pos=c(1,1))
29.05/(29.05+42.58342)
carma(y,pre=1,pos=c(1,1),torder=4)
35.84/(35.84+23.93034)
carma(y,trans="log")
carma(y,trans="log",pre=1,pos=c(1,1))

my <- matrix(resp,ncol=5,byrow=T)
# Different intensity functions
coxre(my,cens=matrix(rep(1,55),ncol=5),nest=1:11,est=0.7,stratified=T)
# Proportional intensity functions
coxre(my,cens=matrix(rep(1,55),ncol=5),nest=1:11,est=0.7,stratified=F)
# Identical intensity functions
coxre(response(y),cens=rep(1,55),nest=rep(1:11,rep(5,11)),est=0.7)

if(interactive()){
postscript("probe.eps",height=5)
par(mfrow=c(1,2))
#plot(km(resp),xlim=c(0,55),xlab="Seconds",ylab="Survival function",main="")
#lines(1:50,exp(z$coef[2])/(exp(z$coef[2])+((1:50)/
#	exp(z$coef[1]))^exp(z$coef[3])),lty=3)
#plot(1:50,exp(z$coef[2])*exp(z$coef[3])*(((1:50)/exp(z$coef[1]))^
#	(exp(z$coef[3])-1)/exp(z$coef[1]))/(exp(z$coef[2])+((1:50)
#	/exp(z$coef[1]))^exp(z$coef[3])),type="l",xlab="Seconds",
#	ylab="Intensity function",ylim=c(0,0.1))
plot(km(resp),group=gl(5,1,55),xlim=c(0,55),xlab="Seconds",
	ylab="Survival function",main="")
lines(1:50,exp(zz$coef[6])/(exp(zz$coef[6])+((1:50)/
	exp(zz$coef[1]))^exp(zz$coef[7])))
lines(1:50,exp(zz$coef[6])/(exp(zz$coef[6])+((1:50)/
	exp(zz$coef[1]+zz$coef[2]))^exp(zz$coef[7])),lty=2)
lines(1:50,exp(zz$coef[6])/(exp(zz$coef[6])+((1:50)/
	exp(zz$coef[1]+zz$coef[3]))^exp(zz$coef[7])),lty=3)
lines(1:50,exp(zz$coef[6])/(exp(zz$coef[6])+((1:50)/
	exp(zz$coef[1]+zz$coef[4]))^exp(zz$coef[7])),lty=4)
lines(1:50,exp(zz$coef[6])/(exp(zz$coef[6])+((1:50)/
	exp(zz$coef[1]+zz$coef[5]))^exp(zz$coef[7])),lty=1)
plot(1:50,exp(zz$coef[6])*exp(zz$coef[7])*(((1:50)/exp(zz$coef[1]))^
	(exp(zz$coef[7])-1)/exp(zz$coef[1]))/(exp(zz$coef[6])+((1:50)
	/exp(zz$coef[1]))^exp(zz$coef[7])),type="l",xlab="Seconds",
	ylab="Intensity function",ylim=c(0,0.3))
lines(1:50,exp(zz$coef[6])*exp(zz$coef[7])*(((1:50)/exp(zz$coef[1]
	+zz$coef[2]))^(exp(zz$coef[7])-1)/exp(zz$coef[1]+zz$coef[2]))
	/(exp(zz$coef[6])+((1:50)/exp(zz$coef[1]+zz$coef[2]))^exp(zz$coef[7])),
	lty=2)
lines(1:50,exp(zz$coef[6])*exp(zz$coef[7])*(((1:50)/exp(zz$coef[1]
	+zz$coef[3]))^(exp(zz$coef[7])-1)/exp(zz$coef[1]+zz$coef[3]))
	/(exp(zz$coef[6])+((1:50)/exp(zz$coef[1]+zz$coef[3]))^exp(zz$coef[7])),
	lty=3)
lines(1:50,exp(zz$coef[6])*exp(zz$coef[7])*(((1:50)/exp(zz$coef[1]
	+zz$coef[4]))^(exp(zz$coef[7])-1)/exp(zz$coef[1]+zz$coef[4]))
	/(exp(zz$coef[6])+((1:50)/exp(zz$coef[1]+zz$coef[4]))^exp(zz$coef[7])),
	lty=4)
lines(1:50,exp(zz$coef[6])*exp(zz$coef[7])*(((1:50)/exp(zz$coef[1]
	+zz$coef[5]))^(exp(zz$coef[7])-1)/exp(zz$coef[1]+zz$coef[5]))
	/(exp(zz$coef[6])+((1:50)/exp(zz$coef[1]+zz$coef[5]))^exp(zz$coef[7])),
	lty=1)
}
