library(repeated)
library(event)
library(gnlm)

resp <- read.table("ratsurv.dat",skip=6)
reps <- rmna(restovec(cbind(resp[,1],resp[,3],resp[,5]),
	cens=cbind(resp[,2],resp[,4],resp[,6])),
	tvc=tvctomat(matrix(rep(c(0,1,1),50),ncol=3,byrow=T),name="treat"))

mu <- function(p,linear) exp(linear)
gnlmm(reps,"Weibull",pmu=c(4.7,0.2),mu=mu,linear=~treat,psh=1.4,
	points=11,psd=0.18)
print(z <- gnlr(reps,"Weibull",pmu=c(5,0.2),mu=mu,linear=~treat,psh=1))
gnlr(reps,"Weibull",pmu=150,mu=~1,psh=1)
print(zwf <- kalsurv(reps,dep="frailty",int="Weibull",psh=4,preg=5,
	tvcov=~treat,ptvc=0))

if(interactive()){
postscript("ratsurv.eps",height=5)
par(mfrow=c(1,2),mar=c(3.5,3.5,3,1),mgp=c(2.5,1,0))
plot(km(response(reps)[,1],response(reps)[,2],group=tr),main="",xlab="Weeks",
	ylab="Survival function",xlim=c(0,104))
lines(1:104,1-((1:104)/exp(zwf$coef[1]))^exp(zwf$coef[4]))
lines(1:104,1-((1:104)/exp(zwf$coef[1]+zwf$coef[2]))^exp(zwf$coef[4]),lty=2)
legend(0,0.6,legend=c("Exposed","Control"),lty=1:2,bty="n")
plot(1:104,exp(hweibull(1:104,exp(zwf$coef[4]),exp(zwf$coef[1]))),type="l",
	xlab="Weeks",ylab="Intensity")
lines(1:104,exp(hweibull(1:104,exp(zwf$coef[4]),exp(zwf$coef[1]+zwf$coef[2]))),
	lty=2)
dev.off()
}
