library(gnlm)
library(event)

data <- read.list("mmc.dat",skip=4,nline=1)
cens <- rep(0,19)
y <- tt <- pt <- nt <- cn <- id <- NULL
for(i in 1:19){
      tt <- c(tt,cumsum(data[[i]]))
      pt <- c(pt,c(0,data[[i]][1:(length(data[[i]])-1),1]))
      nt <- c(nt,(1:length(data[[i]]))-1)
      id <- c(id,rep(i,length(data[[i]])))}
id <- as.factor(id)
data <- restovec(data,cens=cens)

print(ze <- kalsurv(data,pinit=0.1,preg=4,dep="frailty"))
print(zeb <- kalsurv(data,pinit=0.001,preg=4.8,pbirth=0,dep="frailty"))
print(zw <- kalsurv(data,pinit=1,preg=5,psh=1,intensity="Weibull",
	dep="frailty"))
print(zwb <- kalsurv(data,pinit=1,preg=5,psh=1,
	intensity="Weibull",pbirth=0,dep="frailty"))
print(zg <- kalsurv(data,pinit=0.1,preg=2,psh=4,intensity="gamma",
	dep="frailty"))
print(zgb <- kalsurv(data,pinit=1,preg=2,psh=4,
	intensity="gamma",pbirth=0,dep="frailty"))
print(zln <- kalsurv(data,pinit=0.1,preg=2,psh=4,
	intensity="log normal",dep="frailty"))
print(zlnb <- kalsurv(data,pinit=0.001,preg=4.7,psh=0.27,
	intensity="log normal",pbirth=0,dep="frailty"))
print(zlc <- kalsurv(data,pinit=0.1,preg=2,psh=4,
	intensity="log Cauchy",dep="frailty"))
print(zlcb <- kalsurv(data,pinit=0.001,preg=4.7,psh=0.27,
	intensity="log normal",pbirth=0,dep="frailty"))

print(zei <- kalsurv(data,pinit=0.01,preg=4.7,dep="independence"))
print(zee <- kalsurv(data,pinit=0.1,pdep=0.9,preg=3,
	dep="serial",upd="event"))
print(zeeb <- kalsurv(data,pinit=0.001,pdep=0.995,preg=5,
	pbirth=0,dep="serial",upd="event"))
print(zem <- kalsurv(data,pinit=0.1,pdep=0.9,preg=5,
	dep="serial",upd="Markov"))
print(zemb <- kalsurv(data,pinit=0.001,pdep=0.2,preg=5,
	pbirth=0,dep="serial",upd="Markov"))
print(zec <- kalsurv(data,pinit=0.01,pdep=0.99,preg=4.8,
	dep="serial",upd="count"))
print(zecb <- kalsurv(data,pinit=0.1,pdep=0.9,preg=5,
	pbirth=0,dep="serial",upd="count"))
print(zeh <- kalsurv(data,pinit=0.1,pdep=0.99,preg=4.8,
	dep="serial",upd="cumulated"))
print(zek <- kalsurv(data,pinit=0.2,pdep=0.5,preg=5,
	dep="serial",upd="kalman"))

print(zwi <- kalsurv(data,pinit=0.7,preg=5,psh=1,
	dep="independence",intensity="Weibull"))
print(zwib <- kalsurv(data,pinit=0.7,preg=5,psh=1,
	pbirth=0,dep="independence",intensity="Weibull"))
print(zwe <- kalsurv(data,pinit=0.7,pdep=0.5,preg=5,psh=1,
	dep="serial",upd="event",intensity="Weibull"))
print(zweb <- kalsurv(data,pinit=0.7,pdep=0.5,preg=5,psh=1,
	pbirth=0,dep="serial",upd="event",intensity="Weibull"))
print(zwm <- kalsurv(data,pinit=0.7,pdep=0.9,preg=5,psh=1,
	dep="serial",upd="Markov",intensity="Weibull"))
print(zwmb <- kalsurv(data,pinit=0.7,pdep=0.9,preg=5,psh=1,
	pbirth=0,dep="serial",upd="Markov",intensity="Weibull"))
print(zwc <- kalsurv(data,pinit=0.7,pdep=0.5,preg=5,psh=1,
	dep="serial",upd="count",intensity="Weibull"))
print(zwcb <- kalsurv(data,pinit=0.7,pdep=0.5,preg=5,psh=1,
	pbirth=0,dep="serial",upd="count",intensity="Weibull"))
print(zwh <- kalsurv(data,pinit=0.7,pdep=0.9,preg=5,psh=1,
	dep="serial",upd="cumulated",intensity="Weibull"))
print(zwk <- kalsurv(data,pinit=0.001,pdep=0.5,preg=5,psh=1,
	dep="serial",upd="kalman",intensity="Weibull"))

print(zgi <- kalsurv(data,pinit=0.001,preg=3.3,psh=3.8,
	dep="independence",intensity="gamma"))
print(zgib <- kalsurv(data,pinit=0.001,preg=3.3,psh=3.8,
	pbirth=-0.1,dep="independence",intensity="gamma"))
print(zgm <- kalsurv(data,pinit=0.00001,pdep=0.9,preg=3.3,psh=1.3,
	dep="serial",upd="Markov",intensity="gamma"))
print(zgmb <- kalsurv(data,pinit=0.0001,pdep=0.01,preg=3.4,psh=4.1,
	pbirth=-0.19,dep="serial",upd="Markov",intensity="gamma"))

print(zlnm <- kalsurv(data,pinit=0.001,pdep=0.98,preg=5,psh=1,
	dep="serial",upd="Markov",intensity="log normal"))
print(zlcm <- kalsurv(data,pinit=0.001,pdep=0.98,preg=5,psh=3,
	dep="serial",upd="Markov",intensity="log Cauchy"))
print(zllm <- kalsurv(data,pinit=0.001,pdep=0.98,preg=5,psh=0.1,
	dep="serial",upd="Markov",intensity="log logistic"))

gnlr(data,"exponential",pmu=5,mu=~exp(a))
gnlr(data,"gamma",pmu=5,psh=1,mu=~exp(a))
gnlr(data,"Weibull",pmu=5,psh=1,mu=~exp(a))
gnlr(data,"Pareto",pmu=5,psh=1,mu=~exp(a))

mu <- function(p,linear) exp(linear)
gnlr(data,"exponential",pmu=c(5,0),mu=mu,linear=~nt)
gnlr(data,"gamma",pmu=c(5,0),psh=1,mu=mu,linear=~nt)
gnlr(data,"Weibull",pmu=c(5,0),psh=1,mu=mu,linear=~nt)
gnlr(data,"Pareto",pmu=c(4.75,-0.015),psh=1,mu=mu,linear=~nt)

gnlr3(data,"Weibull",pmu=5,psh=1,pfam=1,mu=~exp(a))
gnlr3(data,"gamma",pmu=4,psh=2,pfam=-0.3,mu=~exp(a))

gnlr3(data,"Burr",pmu=5,psh=1,pfam=1,mu=~exp(a))
gnlr3(data,"Burr",pmu=c(10,0),psh=0.9,pfam=1,mu=mu,linear=~tt)
gnlr3(data,"Burr",pmu=5.2,mu=~exp(a),psh=c(0.9,0.001),pfam=1.2,shape=~tt)
gnlr3(data,"Burr",pmu=5.2,mu=~exp(a),psh=0.9,pfam=c(1.2,0.001),fam=~tt)

gnlr3(data,"Burr",pmu=c(10,0),psh=0.9,pfam=1,mu=mu,linear=~pt)
gnlr3(data,"Burr",pmu=5.2,mu=~exp(a),psh=c(0.9,0.001),pfam=1.2,shape=~pt)
gnlr3(data,"Burr",pmu=5.2,mu=~exp(a),psh=0.9,pfam=c(1.2,0.001),fam=~pt)

gnlr3(data,"Burr",pmu=c(10,0),psh=0.9,pfam=1,mu=mu,linear=~nt)
gnlr3(data,"Burr",pmu=5.2,mu=~exp(a),psh=c(0.9,0.001),pfam=1.2,shape=~nt)
gnlr3(data,"Burr",pmu=5.2,mu=~exp(a),psh=0.9,pfam=c(1.2,0.1),fam=~nt)
gnlr3(data,"Burr",pmu=5.2,mu=~exp(a),psh=0.9,pfam=c(1.2,0.1,0),
	fam=~nt+I(nt^2),iter=200)
gnlr3(data,"Burr",pmu=c(5.2,0),mu=mu,linear=~nt,psh=0.9,
	pfam=c(1.2,0.1),fam=~nt)

gnlr3(data,"Burr",pmu=c(5.6,rep(0,18)),psh=1,pfam=3.2,mu=mu,linear=~id,
	iter=200)
gnlr3(data,"Burr",pmu=c(4.5,0.0005,rep(0,18)),psh=0.93,pfam=1,mu=mu,
	linear=~tt+id,iter=200)
gnlr3(data,"Burr",pmu=c(5.6,rep(0,18)),mu=mu,linear=~id,
	psh=c(0.9,0.001),pfam=1.2,shape=~tt,iter=200)
gnlr3(data,"Burr",pmu=c(4.4,rep(0,18)),mu=mu,linear=~id,psh=0.96,
	pfam=c(1.26,0.0007),fam=~tt,iter=200)
gnlr3(data,"Burr",pmu=c(6,rep(0,18)),mu=mu,linear=~id,
	psh=c(0.9,0.001),pfam=1.2,shape=~pt,iter=200)
gnlr3(data,"Burr",pmu=c(6.8,rep(0.2,18)),mu=mu,linear=~id,psh=0.98,
	pfam=c(6.1,0.005),fam=~pt,iter=200)

# number of unique uncensored observations = 77
length(unique(data$y))

# number of ties = 0
sum(data$y==0)

# number censored/number = 19/19
length(cens)-sum(cens)
length(data$nobs)
