library(event)
library(gnlm)

times <- read.list("valve.dat",skip=4,nline=1)
tt <- list()
for(i in times)tt <- c(tt,list(c(i[1],diff(i))))
cens <- rep(0,41)
tt <- restovec(tt,cens=cens)

print(ze <- kalsurv(tt,pinit=0.7,preg=2,dep="frailty"))
print(zeb <- kalsurv(tt,pinit=0.7,preg=2,pbirth=0,dep="frailty"))
print(zw <- kalsurv(tt,pinit=0.7,preg=2,psh=1,intensity="Weibull",
	dep="frailty"))
print(zwb <- kalsurv(tt,pinit=0.7,preg=2,psh=1,intensity="Weibull",
	pbirth=0,dep="frailty"))

print(zei <- kalsurv(tt,pinit=0.7,preg=2,dep="independence"))
print(zeib <- kalsurv(tt,pinit=0.1,preg=2,dep="independence",pbirth=0))
print(zee <- kalsurv(tt,pinit=0.7,pdep=0.1,preg=6,dep="serial",upd="event"))
print(zeeb <- kalsurv(tt,pinit=0.7,pdep=0.5,preg=6,
	pbirth=0,dep="serial",upd="event"))
print(zem <- kalsurv(tt,pinit=0.1,pdep=0.9,preg=2,dep="serial",upd="Markov"))
print(zemb <- kalsurv(tt,pinit=0.7,pdep=0.9,preg=2,
	pbirth=0,dep="serial",upd="Markov"))
print(zec <- kalsurv(tt,pinit=0.7,pdep=0.5,preg=2,dep="serial",upd="count"))
print(zeh <- kalsurv(tt,pinit=1,pdep=0.1,preg=2,
	dep="serial",upd="cumulated"))
print(zek <- kalsurv(tt,pinit=1,pdep=0.1,preg=1,dep="serial",upd="kalman"))

print(zwi <- kalsurv(tt,pinit=0.7,preg=2,psh=1,
	dep="independence",intensity="Weibull"))
print(zwib <- kalsurv(tt,pinit=2,preg=5.5,psh=1.7,
	pbirth=0,dep="independence",intensity="Weibull"))
print(zwe <- kalsurv(tt,pinit=0.7,pdep=0.85,preg=7,psh=1,
	dep="serial",upd="event",intensity="Weibull"))
print(zweb <- kalsurv(tt,pinit=0.7,pdep=0.1,preg=7,psh=1,
	pbirth=0,dep="serial",upd="event",intensity="Weibull"))
print(zwm <- kalsurv(tt,pinit=0.7,pdep=0.85,preg=7,psh=1,
	dep="serial",upd="Markov",intensity="Weibull"))
print(zwmb <- kalsurv(tt,pinit=0.7,pdep=0.85,preg=7,psh=1,
	pbirth=0,dep="serial",upd="Markov",intensity="Weibull"))
print(zwc <- kalsurv(tt,pinit=0.7,pdep=0.5,preg=2,psh=1,
	dep="serial",upd="count",intensity="Weibull"))
print(zwh <- kalsurv(tt,pinit=0.7,pdep=0.5,preg=2,psh=1,
	dep="serial",upd="cumulated",intensity="Weibull"))
print(zwk <- kalsurv(tt,pinit=0.7,pdep=0.5,preg=2,psh=1,
	dep="serial",upd="kalman",intensity="Weibull"))

print(zci <- kalsurv(tt,pinit=0.1,preg=2,psh=1,
	dep="independence",intensity="log Cauchy"))
print(zli <- kalsurv(tt,pinit=0.1,preg=2,psh=1,
	dep="independence",intensity="log logistic"))
print(zni <- kalsurv(tt,pinit=0.1,preg=2,psh=1,
	dep="independence",intensity="log normal"))
print(zgi <- kalsurv(tt,pinit=0.1,preg=5,psh=1,
	dep="independence",intensity="gamma"))
#print(zti <- kalsurv(tt,pinit=0.25,preg=6,psh=1.5,
#	dep="independence",intensity="log Student",print.level=2))

cn <- rep(1,length(zei$resp$y))
cn[cumsum(zei$resp$nobs)] <- cens
y <- cbind(ifelse(zei$resp$y>0,zei$resp$y,0.01),cn)
gnlr(y,"exponential",pmu=500,delta=cn)
gnlr(y,"Weibull",pmu=500,pshape=0,delta=cn)
gnlr(y,"gamma",pmu=500,pshape=0,delta=cn)
birth <- log(sequence(zei$resp$nobs))
mu <- function(p) exp(p[1]+p[2]*birth)
gnlr(y,"exponential",pmu=c(8,-1),mu=mu,delta=cn)
gnlr(y,"Weibull",pmu=c(8,-1),pshape=0,mu=mu,delta=cn)

# number of unique uncensored observations = 84
length(unique(zei$resp$y[cn>0]))

# number of ties = 2
sum(zei$resp$y==0)

# number censored/number = 41/41
length(cens)-sum(cens)
length(cens)
